<script setup lang="ts">
export interface ICharacter {
    id: number,
    name: string,
    status: string
    species: string,
    image: string,
}

interface IResult {
    info: {
        next: string,
        prev: string,
    },
    results: ICharacter[]
}


const route = useRoute()
const router = useRouter()
const pageQuery = computed(() => {
    const page = Array.isArray(route.query.page) ? route.query.page.at(0) : route.query.page
    return Number(page) || 1
})

const nameQuery = computed(() => {
    const name = Array.isArray(route.query.name) ? route.query.name.at(0) : route.query.name
    return name || undefined
})

const { data, refresh, error } = useAsyncData<IResult>('characters', () => $fetch('https://rickandmortyapi.com/api/character', { query: { page: pageQuery.value, name: nameQuery.value } }))

const handlePrevious = async () => {
    await router.push({ query: { ...route.query, page: (pageQuery.value - 1) } })
    refresh()
}

const handleNext = async () => {
    await router.push({ query: { ...route.query, page: (pageQuery.value + 1) } })
    refresh()
}

const search = ref(nameQuery.value)

const handleSearch = async () => {
    console.log('click')
    await router.push({ query: { ...route.query, name: search.value, page: 1 } })
    refresh()
}
</script>


<template>

<div>
    <div class="flex gap-2 mb-4">
        <form @submit.prevent="">
            <input placeholder="Search character" v-model="search" > 
            <button @click="handleSearch" class="bg-blue-300 px-2 py-1 rounded-lg hover:bg-opacity-75">Search</button>
        </form>
        <button @click="handlePrevious" :disabled="!Boolean(data?.info?.prev)" class="bg-blue-300 px-2 py-1 rounded-lg hover:bg-opacity-75 disabled:bg-slate-200">Previous</button>
        <span>{{ pageQuery }}</span>
        <button @click="handleNext" :disabled="!Boolean(data?.info?.next)" class="bg-blue-300 px-2 py-1 rounded-lg hover:bg-opacity-75 disabled:bg-slate-200">Next</button>
    </div>

    <p v-if="error">There is no data</p>
    <ul v-else-if="data">
        <li v-for="character in data.results" :key="character.id">
            <NuxtLink :to="{ name: 'characters-id', params: { id: character.id } }">
                {{ character.name }}
            </NuxtLink>
        </li>
    </ul>
</div>
</template>

